package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20062ReqBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot20062YunCarSale extends ProtBase  {
	
	private final short iTaskCode20062 = 20062;
	private Gson gson;
	private ProtStatusResBean statusResBean;
	
	public Prot20062YunCarSale() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	/*public String getJsonData() {
		return jsonData;
	}*/
	public ProtStatusResBean getResBean(){
		return this.statusResBean;
	}
	
	public void submitActivateInfo(SocketCreate create, Prot20062ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot20062ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20062, "开始提交激活信息");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20062, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20062, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			statusResBean = gson.fromJson(jsonData, ProtStatusResBean.class);
		}
		System.err.println("resBean: " + statusResBean.toString());
		
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20062ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		debugLog(iTaskCode20062, "发送的数据格式：" + bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20062, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}

